<?php

/*
Plugin Name: Plurk for Wordpress
Version: 1.0.1
Plugin URI: http://rick.jinlabs.com/code/plurk
Description: Displays your public Plurk messages for all to read. Based on <a href="http://cavemonkey50.com/code/pownce/">Pownce for Wordpress</a> by <a href="http://cavemonkey50.com/">Cavemonkey50</a>.
Author: Ricardo Gonz&aacute;lez
Author URI: http://rick.jinlabs.com/
*/

/*  Copyright 2007  Ricardo Gonzlez Castro (rick[at]jinlabs.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

//define('MAGPIE_CACHE_AGE', 120);
define('MAGPIE_CACHE_ON', 0); //2.7 Cache Bug
define('MAGPIE_INPUT_ENCODING', 'UTF-8');
define('MAGPIE_OUTPUT_ENCODING', 'UTF-8');

$plurk_options['widget_fields']['title'] = array('label'=>'Title:', 'type'=>'text', 'default'=>'');
$plurk_options['widget_fields']['username'] = array('label'=>'Username:', 'type'=>'text', 'default'=>'');
$plurk_options['widget_fields']['num'] = array('label'=>'Number of links:', 'type'=>'text', 'default'=>'5');
$plurk_options['widget_fields']['update'] = array('label'=>'Show timestamps:', 'type'=>'checkbox', 'default'=>true);
$plurk_options['widget_fields']['linked'] = array('label'=>'Linked:', 'type'=>'text', 'default'=>'#');
$plurk_options['widget_fields']['encode_utf8'] = array('label'=>'UTF8 Encode:', 'type'=>'checkbox', 'default'=>false);


$plurk_options['prefix'] = 'plurk';

// Display Plurk messages
function plurk_messages($username = '', $num = 1, $list = false, $update = true, $linked  = '#',$encode_utf8 = false) {

	global $plurk_options;
	include_once(ABSPATH . WPINC . '/rss.php');
	
	$messages = fetch_rss('http://www.plurk.com/user/'.$username.'.xml');

	if ($list) echo '<ul class="plurk">';
	
	if ($username == '') {
		if ($list) echo '<li>';
		echo 'RSS not configured';
		if ($list) echo '</li>';
	} else {
			if ( empty($messages->items) ) {
				if ($list) echo '<li>';
				echo 'No public Plurk messages.';
				if ($list) echo '</li>';
			} else {
				foreach ( $messages->items as $message ) {
          if ($message['author']['name'] != $username) {
              $msg = $message['atom_content'];
              if($encode_utf8) $msg = utf8_encode($msg);
              $link = 'http://www.plurk.com'.$message['link_'];
            
              if ($list) echo '<li class="plurk-item">'; elseif ($num != 1) echo '<p class="plurk-message">';
              
              if ($linked != '' || $linked != false) {
                if($linked == 'all')  { 
                  $msg = ' <a href="'.$link.'" class="plurk-link">'.$msg.'</a>';  // Puts a link to the status of each tweet 
                } else {
                  $msg = $msg . ' <a href="'.$link.'" class="plurk-link">'.$linked.'</a>'; // Puts a link to the status of each tweet
                }
              } 
              echo $msg;
              
              
            if($update) {				
              $time = strtotime($message['published']);
              
              if ( ( abs( time() - $time) ) < 86400 )
                $h_time = sprintf( __('%s ago'), human_time_diff( $time ) );
              else
                $h_time = date(__('Y/m/d'), $time);

              echo sprintf( __('%s', 'plurk-for-wordpress'),' <span class="plurk-timestamp"><abbr title="' . date(__('Y/m/d H:i:s'), $time) . '">' . $h_time . '</abbr></span>' );
             }          
                      
              if ($list) echo '</li>'; elseif ($num != 1) echo '</p>';
            
              $i++;
              if ( $i >= $num ) break;
					}
				}
			}
		}
		if ($list) echo '</ul>';
	}   

// Plurk widget stuff
function widget_plurk_init() {

	if ( !function_exists('register_sidebar_widget') )
		return;
	
	$check_options = get_option('widget_plurk');
  if ($check_options['number']=='') {
    $check_options['number'] = 1;
    update_option('widget_plurk', $check_options);
  }
  
	function widget_plurk($args, $number = 1) {

		global $plurk_options;
		
		// $args is an array of strings that help widgets to conform to
		// the active theme: before_widget, before_title, after_widget,
		// and after_title are the array keys. Default tags: li and h2.
		extract($args);

		// Each widget can store its own options. We keep strings here.
		include_once(ABSPATH . WPINC . '/rss.php');
		$options = get_option('widget_plurk');
		
		// fill options with default values if value is not set
		$item = $options[$number];
		foreach($plurk_options['widget_fields'] as $key => $field) {
			if (! isset($item[$key])) {
				$item[$key] = $field['default'];
			}
		}
		
		$messages = fetch_rss('http://plurk.com/statuses/user_timeline/'.$username.'.rss');


		// These lines generate our output.
		echo $before_widget . $before_title . $item['title'] . $after_title;
		plurk_messages($item['username'], $item['num'], true, $item['update'], $item['linked'],$item['encode_utf8']);
		echo $after_widget;
				
	}

	// This is the function that outputs the form to let the users edit
	// the widget's title. It's an optional feature that users cry for.
	function widget_plurk_control($number) {
	
		global $plurk_options;

		// Get our options and see if we're handling a form submission.
		$options = get_option('widget_plurk');
		if ( isset($_POST['plurk-submit']) ) {

			foreach($plurk_options['widget_fields'] as $key => $field) {
				$options[$number][$key] = $field['default'];
				$field_name = sprintf('%s_%s_%s', $plurk_options['prefix'], $key, $number);

				if ($field['type'] == 'text') {
					$options[$number][$key] = strip_tags(stripslashes($_POST[$field_name]));
				} elseif ($field['type'] == 'checkbox') {
					$options[$number][$key] = isset($_POST[$field_name]);
				}
			}

			update_option('widget_plurk', $options);
		}

		foreach($plurk_options['widget_fields'] as $key => $field) {
			
			$field_name = sprintf('%s_%s_%s', $plurk_options['prefix'], $key, $number);
			$field_checked = '';
			if ($field['type'] == 'text') {
				$field_value = htmlspecialchars($options[$number][$key], ENT_QUOTES);
			} elseif ($field['type'] == 'checkbox') {
				$field_value = 1;
				if (! empty($options[$number][$key])) {
					$field_checked = 'checked="checked"';
				}
			}
			
			printf('<p style="text-align:right;" class="plurk_field"><label for="%s">%s <input id="%s" name="%s" type="%s" value="%s" class="%s" %s /></label></p>',
				$field_name, __($field['label']), $field_name, $field_name, $field['type'], $field_value, $field['type'], $field_checked);
		}

		echo '<input type="hidden" id="plurk-submit" name="plurk-submit" value="1" />';
	}
	
	function widget_plurk_setup() {
		$options = $newoptions = get_option('widget_plurk');
		
		if ( isset($_POST['plurk-number-submit']) ) {
			$number = (int) $_POST['plurk-number'];
			$newoptions['number'] = $number;
		}
		
		if ( $options != $newoptions ) {
			update_option('widget_plurk', $newoptions);
			widget_plurk_register();
		}
	}
	
	
	function widget_plurk_page() {
		$options = $newoptions = get_option('widget_plurk');
	?>
		<div class="wrap">
			<form method="POST">
				<h2><?php _e('Plurk Widgets'); ?></h2>
				<p style="line-height: 30px;"><?php _e('How many Plurk widgets would you like?'); ?>
				<select id="plurk-number" name="plurk-number" value="<?php echo $options['number']; ?>">
	<?php for ( $i = 1; $i < 10; ++$i ) echo "<option value='$i' ".($options['number']==$i ? "selected='selected'" : '').">$i</option>"; ?>
				</select>
				<span class="submit"><input type="submit" name="plurk-number-submit" id="plurk-number-submit" value="<?php echo attribute_escape(__('Save')); ?>" /></span></p>
			</form>
		</div>
	<?php
	}
	
	
	function widget_plurk_register() {
		
		$options = get_option('widget_plurk');
		$dims = array('width' => 300, 'height' => 300);
		$class = array('classname' => 'widget_plurk');

		for ($i = 1; $i <= 9; $i++) {
			$name = sprintf(__('Plurk #%d'), $i);
			$id = "plurk-$i"; // Never never never translate an id
			wp_register_sidebar_widget($id, $name, $i <= $options['number'] ? 'widget_plurk' : /* unregister */ '', $class, $i);
			wp_register_widget_control($id, $name, $i <= $options['number'] ? 'widget_plurk_control' : /* unregister */ '', $dims, $i);
		}
		
		add_action('sidebar_admin_setup', 'widget_plurk_setup');
		add_action('sidebar_admin_page', 'widget_plurk_page');
	}

	widget_plurk_register();
}

// Run our code later in case this loads prior to any required plugins.
add_action('widgets_init', 'widget_plurk_init');

?>